PackageEntry (Java SE 25 & JDK 25)
Description: declaration: module: java.base, package: java.lang.classfile.constantpool, interface: PackageEntry
Keywords: java.lang.classfile.constantpool.PackageEntry interface

# Interface PackageEntry

All Superinterfaces:
  `PoolEntry`

public sealed interface PackageEntry extends PoolEntry
Models a `CONSTANT_Package_info`, representing a package, in the constant pool of a `class` file.

The use of a `PackageEntry` is represented by a `PackageDesc` that does not represent the unnamed package. Conversions are through `ConstantPoolBuilder.packageEntry(PackageDesc)` and `asSymbol()`.

A package entry is composite:

    PackageEntry(Utf8Entry name)

where `name` is the internal form of a binary package name and is not empty.

See Java Virtual Machine Specification:
  4.4.12 The `CONSTANT_Package_info` Structure
Since:
  24

- ## Field Summary

  ### Fields declared in interface PoolEntry

  `TAG_CLASS, TAG_DOUBLE, TAG_DYNAMIC, TAG_FIELDREF, TAG_FLOAT, TAG_INTEGER, TAG_INTERFACE_METHODREF, TAG_INVOKE_DYNAMIC, TAG_LONG, TAG_METHOD_HANDLE, TAG_METHOD_TYPE, TAG_METHODREF, TAG_MODULE, TAG_NAME_AND_TYPE, TAG_PACKAGE, TAG_STRING, TAG_UTF8`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PackageDesc`
  `asSymbol()`
  Returns a symbolic descriptor for the package name.
  `boolean`
  `matches(PackageDesc desc)`
  Returns whether this entry describes the given package.
  `Utf8Entry`
  `name()`
  Returns the internal form of the package name.

  ### Methods declared in interface PoolEntry

  `constantPool, index, tag, width`

- ## Method Details

  - ### name

    Utf8Entry name()
    Returns the internal form of the package name.
    Returns:
      the internal form of the package name

  - ### asSymbol

    PackageDesc asSymbol()
    Returns a symbolic descriptor for the package name.
    API Note:
      If only symbol equivalence is desired, `matches` should be used. It requires reduced parsing and can improve `class` file reading performance.
    Returns:
      a symbolic descriptor for the package name

  - ### matches

    boolean matches(PackageDesc desc)
    Returns whether this entry describes the given package.
    Parameters:
      `desc` - the package descriptor
    Returns:
      whether this entry describes the given package
    Since:
      25